package com.javahonk.report;

import java.io.File;
import java.io.IOException;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.AbstractApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.mail.SimpleMailMessage;

import com.javahonk.report.util.MailHelper;

public class SendEmailUsingFreeMarker {
	
	private static final Logger logger = LogManager.getLogger(SendEmailUsingFreeMarker.class);

	public static void main(String[] args) throws BeansException, IOException {
		
		logger.info("Application is starting");
		
		ApplicationContext context = new ClassPathXmlApplicationContext("spring-context.xml");
		
		SimpleMailMessage successTemplate = (SimpleMailMessage)context.getBean("successTemplate");
		
		SimpleMailMessage errorTemplate = (SimpleMailMessage)context.getBean("errorTemplate");
		
		Map<String, File> attachments = new HashMap<String, File>();
		attachments.put("JavaHonk.xlsx", new File("JavaHonk.xlsx"));
		
		List<String> toAddress = new ArrayList<String>();
		toAddress.add("To_javahonk@javahonk.com");	
		
		//Send message using Free Marker template
		Map<String, Object> freeMarkderTemplateMap = new HashMap<String, Object>();
		
		freeMarkderTemplateMap.put("startDate", LocalDate.now());
		freeMarkderTemplateMap.put("endDate", LocalDate.now());
		
		List<String> toAddressList = new ArrayList<String>();
		toAddressList.add("To_JavaHOnk@JavaHonk.com");
		
		context.getBean(MailHelper.class).sendTemplatedMimeMessage(freeMarkderTemplateMap, "JavaHonkFreeMarkerTemplate.ftl", toAddressList, attachments);
		
		//Send mail with attachment
		context.getBean(MailHelper.class).sendMimeMessage(
				"Message: Reponse sent successfully",
				"From_javahonk@javahonk.com", toAddress,
				"Subject: Send email using Spring framework", attachments);
		
		//Simple message configure in spring context file
		context.getBean(MailHelper.class).sendSimpleMailMessage(successTemplate, "Java Honk Test Message");
		
		//Error template to send message in case or error
		context.getBean(MailHelper.class).sendSimpleMailMessage(errorTemplate, "Java Honk Error Message");
		
		((AbstractApplicationContext) context).close();

	}

}
